
unit TetPanel;
{
 TTetPanel component for Borland DELPHI, Version 3.0.

 (C) Alexander Gogava, Tbilisi, Rep. of Georgia. 1998.

           E - mail   alex@argosoft.com

      This component can be use like the TetPanel in all applications,
 because It has all published and public properties of  the TetPanel.

 If You use Delphi 1.0

    To install this component in your VCL place the file TetPanel.pas and
 TetPanel.16 in your C:\DELPHI\LIB directory. From Options menu select
 Install Components... In the Install Components dialogue box click
 Add Button, then in Add Module box type C:\DELPHI\LIB\TetPanel.PAS,
 click OK, then in the Install Components Dialogue box click OK
 again and wait while TetPanel icon will appear in the Additional
 section of the your Components Palette.

 If You use Delphi 2.0

    To install this component in your VCL place the file TetPanel.pas
 in your C:\BORLAND\DELPHI20\LIB directory and from Component
 menu select Install . In the Install Components dialogue box click Add Button,
 then in Add Module box type C:\BORLAND\DELPHI20\LIB\TetPanel.PAS, click OK,
 then in the Install Components Dialogue box click OK again and wait  while
 TetPanel icon will appear in the Additional section of the your Components Palette.

 Regards

 Alexander Gogava

 alex@argosoft.com
}
interface
{$IFDEF Win32}
uses
   SysUtils, Windows, Messages, Classes, Graphics, Controls,
   Forms, Dialogs, ExtCtrls, StdCtrls, Menus, DsgnIntf, Buttons;
{$ELSE}
uses
   SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
   Controls, Forms, Dialogs, ExtCtrls, StdCtrls, Menus, DsgnIntf,
   Buttons;
{$ENDIF}
type
TTSAKey = (Lft, Rgh, Drp, Rtt);
TColorTAFShapes = (colorFixed, colorFixed2, colorOne, colorRandom);
TState = (StPanel, Tetris);
TTetPanel = class (TPanel)
private
    Pict: TPicture;
    FAbout, FBStPicture, FAOverPicture: string;
    fx, fy, fcx, fcy, FWidthTShapesPen, FTCoeff,
    FTScores, FTLines:Integer;
    FTime: Real;
    FStyle: Longint;
    FState: TState;
    FShowScoresTime, FWithCaption,
    FStart, FPause, FNextSColorT, FShowAllDlgs, FPicStretch,
    FTimerFocus, FDefKeys: Boolean;
    FTDelay : Integer;
    FGKey: TTSAKey;
    FABalls, FABlls: Integer;
    FColorTB, FColorTF, FColorTShapesPen,
    FOneColorTShapes: TColor;
    FColorTShapes: TColorTAFShapes;
    FShapesTShape: TShapeType;
    FShapesTBrushStyle: TBrushStyle;
    FOnTetrisTime, FOnTetrisOver, FOnTetrisDelete, FOnTetrisContact, FOnArcanoidContact: TNotifyEvent;
    FNextTShape, FTColumns, FTRows: Word;
    procedure Resize; Override;
    procedure SetState (Value: TState);
    procedure SetStart (Value: Boolean);
    procedure SetPause (Value: Boolean);
    procedure SetPicStretch (Value: Boolean);
    procedure SetGKey (Value: TTSAKey);
    procedure SetColorTF (Value: TColor);
    procedure SetColorTB (Value: TColor);
    procedure SetOneColorTShapes (Value: TColor);
    procedure SetColorTShapes (Value: TColorTAFShapes);
    procedure SetShapesTShape (Value: TShapeType);
    procedure SetShapesTBrushStyle (Value: TBrushStyle);
    procedure SetColorTShapesPen (Value: TColor);
    procedure SetWidthTShapesPen (Value: Integer);
    procedure SetTDelay (Value: Integer);
    procedure SetNextSColorT (Value: Boolean);
    procedure SetNextTShape (Value: Word);
    procedure SetShowScoresTime (Value: Boolean);
    procedure SetShowAllDlgs (Value: Boolean);
    procedure ChangeState;
    procedure ChangeParams;
    procedure TetPanelKeyDown (Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure TetrisDelete (Sender: TObject);
    procedure TetrisOver (Sender: TObject);
    procedure TetrisContact (Sender: TObject);
    procedure TetrisPaint (Sender: TObject);
    procedure STAFTime (Sender: TObject);
    procedure SeTTRows (Value: Word);
    procedure SeTTColumns (Value: Word);
    procedure SetBStPicture (Value: string);
    procedure SetAOverPicture (Value: string);
    procedure SetWithCaption (Value: Boolean);
    procedure SetTCoeff (Value: Integer);
    procedure SetTimerFocus (Value: Boolean);
    procedure SetDefKeys (Value: Boolean);
    procedure PanelSetFocus;
protected
public
    constructor Create (AOwner: TComponent); Override;
    destructor Destroy; Override;
    Property GKey: TTSAKey read FGKey write SetGKey;
    Property Pause: Boolean read FPause write SetPause default False;
    Property Time: Real read FTime;
    Property NextTShape: Word read FNextTShape write SetNextTShape default 7;
    Property TLines: Integer read FTLines default 0;
    Property TScores: Integer read FTScores default 0;
published
    Property About: string read FAbout write FAbout stored False;
    Property State: TState read FState write SetState default stPanel;
    Property Start: Boolean read FStart write SetStart default False;
    Property PicStretch: Boolean read FPicStretch Write SetPicStretch default True;
    Property ColorTB: TColor read FColorTB write SetColorTB default clBlack;
    Property ColorTF: TColor read FColorTF write SetColorTF default clBlack;
    Property ColorTShapes: TColorTAFShapes read FColorTShapes write SetColorTShapes default colorFixed;
    Property ColorTShapesPen: TColor read FColorTShapesPen write SetColorTShapesPen default clWhite;
    Property WidthTShapesPen: Integer read FWidthTShapesPen write SetWidthTShapesPen default 1;
    Property TDelay: Integer read FTDelay write SetTDelay default 200;
    Property NextSColorT: Boolean read FNextSColorT write SetNextSColorT default False;
    Property TimerFocus: Boolean read FTimerFocus write SetTimerFocus default false;
    Property DefKeys: Boolean read FDefKeys write SetDefKeys Default True;
    Property OneColorTShapes: TColor read FOneColorTShapes write SetOneColorTShapes default clBtnFace;
    Property ShapesTShape: TShapeType read FShapesTShape write SetShapesTShape default stRoundRect;
    Property ShapesTBrushStyle: TBrushStyle read FShapesTBrushStyle write SetShapesTBrushStyle default bsSolid;
    Property ShowScoresTime: Boolean read FShowScoresTime write SetShowScoresTime default True;
    Property ShowAllDlgs: Boolean read FShowAllDlgs write SetShowAllDlgs default True;
    Property AOverPicture: string read FAOverPicture write SetAOverPicture;
    Property TCoeff: Integer read FTCoeff write SetTCoeff default 1;
    Property BStPicture: string read FBStPicture write SetBStPicture;
    Property TRows: Word read FTRows write SeTTRows default 20;
    Property TColumns: Word read FTColumns write SeTTColumns default 10;
    Property WithCaption: Boolean read FWithCaption write SetWithCaption default True;
    Property OnTetrisTime: TNotifyEvent read FOnTetrisTime write FOnTetrisTime;
    Property OnTetrisOver: TNotifyEvent read FOnTetrisOver write FOnTetrisOver;
    Property OnTetrisDelete: TNotifyEvent read FOnTetrisDelete write FOnTetrisDelete;
    Property OnTetrisContact: TNotifyEvent read FOnTetrisContact write FOnTetrisContact;
end;

                             { Register }

procedure Register;

implementation

                           { TAboutProperty }
type
TAboutProperty = class (TStringProperty)
protected
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
end;
TTtrs = class (TCustomPanel)
private
    Timer1, Timer2: TTimer;
    Panel1: TPanel;
    FColorB, FColorF, FColorShapesPen, FOneColorShapes: TColor;
    FColorShapes: TColorTAFShapes;
    FWidthShapesPen: Integer;
    FShapesShape: TShapeType;
    FShapesBrushStyle: TBrushStyle;
    FTetrisKeyDown: Word;
    FDelay: Integer;
    FStart, FPause, FNextSColor, FFirstFocus: Boolean;
    FNextShape: Word;
    FOnDelete, FOnOver, FOnContact, FOnTime, FOnPaint: TNotifyEvent;
    FTetrisKey: TTSAKey;
    str: string[2];
    x, he, wi: Word;
    FRows: Word;
    FColumns: Word;
    Sh: array[1..48,1..24] of TShape;
    procedure SetDelay (Value: Integer);
    procedure SetStart (Value: Boolean);
    procedure SetPause (Value: Boolean);
    procedure SetColorF (Value: TColor);
    procedure SetColorShapes (Value: TColorTAFShapes);
    procedure SetOneColorShapes (Value: TColor);
    procedure SetColorShapesPen (Value: TColor);
    procedure SetWidthShapesPen (Value: Integer);
    procedure SetShapesShape (Value: TShapeType);
    procedure SetShapesBrushStyle (Value: TBrushStyle);
    procedure SetRows (Value: Word);
    procedure SetColumns (Value: Word);
    procedure SetNextShape (Value: Word);
    procedure SetNextSColor (Value: Boolean);
    procedure SetTetrisKey (Value: TTSAKey);
    procedure SetTetrisKeyDown (Value: Word);
    procedure Paint; Override;
    procedure Resize; Override;
    procedure WMNCHitTest (var Mes: TWMNCHitTest); Message WM_NCHitTest;
    procedure TimerOnTimer (Sender: TObject);
    procedure CreateShapes;
    procedure Left; virtual;
    procedure Right; virtual;
    procedure Rotate; virtual;
    procedure DropDown; virtual;
    procedure CreateShape (var Shape: TShape; i, j, r: ShortInt);
    procedure Timer2OnTimer (Sender: TObject);
    procedure Time;  Dynamic;
    procedure Delete; dynamic;
    procedure Contact; dynamic;
    procedure Over; dynamic;
    procedure EndFlying; virtual;
    Property Align;
    Property Alignment;
    Property BevelInner;
    Property BevelOuter;
    Property BorderStyle;
    Property BorderWidth;
    Property Canvas;
    Property Caption;
    Property Color;
    Property Ctl3D;
    Property DragCursor;
    Property DragMode;
    Property Enabled;
    Property Font;
    Property Locked;
    Property ParentColor;
    Property ParentCtl3D;
    Property ParentFont;
    Property ParentShowHint;
    Property ShowHint;
    Property TabOrder;
    Property TabStop;
    Property Visible;
    Property OnClick;
    Property OnDblClick;
    Property OnDragDrop;
    Property OnDragOver;
    Property OnEndDrag;
    Property OnEnter;
    Property OnExit;
    Property OnMouseDown;
    Property OnMouseMove;
    Property OnMouseUp;
    Property OnResize;
    Property OnKeyDown;
    Property ColorF: TColor read FColorF write SetColorF;
    Property Start: Boolean read FStart write SetStart;
    Property Pause: Boolean read FPause write SetPause;
    Property FirstFocus: Boolean read FFirstFocus;
    Property TetrisKey: TTSAKey read FTetrisKey write SetTetrisKey;
    Property TetrisKeyDown: Word read FTetrisKeyDown write SetTetrisKeyDown;
    Property NextSColor: Boolean read FNextSColor write SetNextSColor;
    Property NextShape: Word read FNextShape write SetNextShape;
    Property ColorShapes: TColorTAFShapes read FColorShapes write SetColorShapes;
    Property OneColorShapes: TColor read FOneColorShapes write SetOneColorShapes;
    Property ShapesShape: TShapeType read FShapesShape write SetShapesShape;
    Property ShapesBrushStyle: TBrushStyle read FShapesBrushStyle write SetShapesBrushStyle;
    Property ColorShapesPen: TColor read FColorShapesPen write SetColorShapesPen;
    Property WidthShapesPen: Integer read FWidthShapesPen write SetWidthShapesPen;
    Property OnOver: TNotifyEvent read FOnOver write FOnOver;
    Property OnContact: TNotifyEvent read FOnContact write FOnContact;
    Property OnDelete: TNotifyEvent read FOnDelete write FOnDelete;
    Property OnTime: TNotifyEvent read FOnTime write FOnTime;
    Property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
    Property Delay: Integer read FDelay write SetDelay;
    Property Rows: Word read FRows write FRows;
    Property Columns: Word read FColumns write FColumns;
    constructor Create (AOwner: TComponent); Override;
    destructor Destroy; Override;
end;


var
temp, Tmp: string;
i,j: integer;
Ttrs1:TTtrs;

                           { Register }

procedure Register;
begin
RegisterComponents ('Additional', [TTetPanel]);
RegisterPropertyEditor (TypeInfo (string), TTetPanel, 'About',
  TAboutProperty);
end;

                          { TAboutProperty }

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
Result := inherited GetAttributes + [paReadOnly, paDialog];
end;

procedure TAboutProperty.Edit;
begin
ShowMessage (' Alexander Gogava 1998');
end;
                         { T e t r i s }

constructor TTtrs.Create (AOwner: TComponent);
begin
inherited Create (AOwner);
Randomize;
FStart := False;
Timer1 := TTimer.Create (Self);
Timer1.OnTimer := TimerOnTimer;
Timer2 := TTimer.Create (Self);
Timer2.OnTimer := Timer2OnTimer;
Panel1 := TPanel.Create (Self);
with Panel1 do
  begin
  Parent := Self; Hide;
  Align := alBottom;
  BevelInner := bvNone;
  BevelOuter := bvRaised;
  BorderStyle := bsSingle;
  Color := ColorF;
  Height := 0;
  end;
for i := 1 to FRows do
  for j := 1 to FColumns do
    Sh[i,j] := nil;
end;

destructor TTtrs.Destroy;
begin
if Timer1 <> nil then
  begin
  Timer1.Free; Timer1 := nil;
  end;
if Timer2 <> nil then
  begin
  Timer2.Free; Timer2 := nil;
  end;
if Panel1 <> nil then
  begin
  Panel1.Free; Panel1 := nil;
  end;
for i := 1 to FRows do
  for j := 1 to FColumns do
    if Sh[i,j] <> nil then
      begin
      Sh[i,j].Free; Sh[i,j] := nil;
      end;
Inherited Destroy;
end;

procedure TTTRS.Timer2OnTimer (Sender: TObject);
begin
if FStart then Time;
end;

procedure TTTRS.Time;
begin
if assigned (FOnTime) then FOnTime (Self);
end;

procedure TTtrs.TimerOnTimer (Sender: TObject);
var
k, i1: ShortInt;
ii,jj: array [1..4] of Shortint;
Cont: boolean;
begin
k := 0;
Cont := false;
for j := 1 to FColumns do
  for i := FRows downto 1 do
    if Sh[i,j] <> nil then
      if Sh[i,j].Tag <> 0 then
        begin
        Inc (k);
        ii[k] := i; jj[k] := j;
        i1 := Succ (i);
        if (i = FRows) or ((Sh[i1,j] <> nil)and(Sh[i1,j].Tag = 0)) then Cont := true;
        if k = 4 then break;
        end;
if k = 4 then
  begin
  if Cont then
    begin
    for k := 1 to 4 do
      begin
      i := ii[k]; j := jj[k];
      Sh[i,j].Tag := 0;
      end;
    EndFlying;
    end
  else
    for k := 1 to 4 do
      begin
      i := ii[k]; j := jj[k];
      i1 := Succ (i);
      Sh[i1,j] := TShape.Create (Self);
      CreateShape (Sh[i1, j], i1, j, Sh[i, j].Tag);
      Sh[i,j].Free;
      Sh[i,j] := nil;
      end;
  end;
end;

procedure TTtrs.CreateShape (var Shape: TShape; i, j, r: ShortInt);
var c: ShortInt;
begin
with Shape do
  begin
  Hide;
  Parent := Self;
  tag := r;
  Shape := FShapesShape;
  Brush.Style := FShapesBrushStyle;
  Pen.Color := FColorShapesPen;
  Pen.Width := FWidthShapesPen;
  case FColorShapes of
    colorOne:     Brush.Color := FOneColorShapes;
    colorRandom:    Brush.Color := RGB (Random (256), Random (256), Random (256));
    colorFixed2:
      begin
      c := Abs (r);
      case c of
        1,8,15,22:  Brush.Color := clAqua;
        2,9,16,23:  Brush.Color := clRed;
        3,10,17,24: Brush.Color := clLime;
        4,11,18,25: Brush.Color := clYellow;
        5,12,19,26: Brush.Color := clBlue;
        6,13,20,27: Brush.Color := clFuchsia;
        7,14,21,28: Brush.Color := clSilver;
        end;
      end;
    colorFixed:
      begin
      c := Abs (r);
      case c of
        1,8,15,22:  Brush.Color := clMaroon;
        2,9,16,23:  Brush.Color := clGreen;
        3,10,17,24: Brush.Color := clOlive;
        4,11,18,25: Brush.Color := clNavy;
        5,12,19,26: Brush.Color := clPurple;
        6,13,20,27: Brush.Color := clTeal;
        7,14,21,28: Brush.Color := clGray;
        end;
      end;
    end;
  SetBounds (wi * Pred (j) + x, he * Pred (i), wi, he);
  Show;
  end;
end;

procedure TTtrs.CreateShapes;
var
i1, j1, i2, j2, i3, j3, i4, j4, ij: ShortInt;
begin
;
ij := Trunc (FColumns div 2);
case FNextShape of
  1:
    begin
    i1 := 1; j1 := ij; i2 := 1; j2 := Succ (ij); i3 := 2; j3 := ij;       i4 := 3; j4 := ij;
    end;
  2:
    begin
    i1 := 1; j1 := ij; i2 := 1; j2 := Pred (ij); i3 := 2; j3 := ij;       i4 := 3; j4 := ij;
    end;
  3:
    begin
    i1 := 2; j1 := ij; i2 := 2; j2 := Pred (ij); i3 := 1; j3 := ij;       i4 := 3; j4 := ij;
    end;
  4:
    begin
    i1 := 2; j1 := ij; i2 := 2; j2 := Succ (ij); i3 := 1; j3 := Succ (ij); i4 := 3; j4 := ij;
    end;
  5:
    begin
    i1 := 2; j1 := ij; i2 := 2; j2 := Pred (ij); i3 := 1; j3 := Pred (ij); i4 := 3; j4 := ij;
    end;
  6:
    begin
    i1 := 2; j1 := ij; i2 := 1; j2 := ij;       i3 := 3; j3 := ij;       i4 := 4; j4 := ij;
    end;
  7:
    begin
    i1 := 2; j1 := ij; i2 := 2; j2 := Succ (ij); i3 := 1; j3 := Succ (ij); i4 := 1; j4 := ij;
    end;
  end;
if (Sh[i1,ij] <> nil) or (Sh[i2,j2] <> nil) or (Sh[i3,j3] <> nil)
    or (Sh[i4,j4] <> nil) then Over
else
  begin
  Sh[i1,j1] := TShape.Create (Self);
  Sh[i2,j2] := TShape.Create (Self);
  Sh[i3,j3] := TShape.Create (Self);
  Sh[i4,j4] := TShape.Create (Self);
  CreateShape (Sh[i1, j1], i1, j1, FNextShape);
  CreateShape (Sh[i2, j2], i2, j2, - FNextShape);
  CreateShape (Sh[i3, j3], i3, j3, - FNextShape);
  CreateShape (Sh[i4, j4], i4, j4, - FNextShape);
  FNextShape := Random (7) + 1;
  SetNextShape (FNextShape);
  Contact;
  end;
end;

procedure TTtrs.Delete;
begin
if assigned (FOnDelete) then FOnDelete (Self);
end;

procedure TTtrs.Contact;
begin
if assigned (FOnContact) then FOnContact (Self);
end;

procedure TTtrs.SetColorShapes (Value: TColorTAFShapes);
begin
if FColorShapes <> Value then FColorShapes := Value;
end;

procedure TTtrs.SetOneColorShapes (Value: TColor);
begin
if FOneColorShapes <> Value then FOneColorShapes := Value;
end;

procedure TTtrs.SetColorShapesPen (Value: TColor);
begin
if FColorShapesPen <> Value then FColorShapesPen := Value;
end;

procedure TTtrs.SetShapesShape (Value: TShapeType);
begin
if FShapesShape <> Value then FShapesShape := Value;
end;

procedure TTtrs.SetDelay (Value: Integer);
begin
if FDelay <> Value then FDelay := Value;
Timer1.Interval := FDelay;
end;

procedure TTtrs.SetStart (Value: Boolean);
begin
if FStart = Value then exit;
FStart := Value;
if FStart then
begin
FNextShape := Random (7) + 1;
FFirstFocus := False;
Align:=alClient;
CreateShapes;
he := Trunc (Height div FRows);
wi := Trunc (Width div FColumns);
x := (Width - FColumns * wi) div 2;
if Panel1 <> nil then
  begin
  Panel1.Height := Height - FRows * he;
  Panel1.Show;
  end;
end;
end;

procedure TTtrs.SetPause (Value: Boolean);
begin
if (FPause = Value) or (Timer1 = nil) or (Timer2 = nil) then exit;
FPause := Value;
Timer1.Enabled := not FPause;
Timer2.Enabled := not FPause;
end;

procedure TTtrs.SetShapesBrushStyle (Value: TBrushStyle);
begin
if FShapesBrushStyle <> Value then FShapesBrushStyle := Value;
end;

procedure TTtrs.SetNextShape (Value: Word);
begin
if FNextShape <> Value then FNextShape := Value;
if FNextSColor = False then exit;
if FColorShapes = ColorFixed then
  case FNextShape of
    1: Color := clMaroon;
    2: Color := clGreen;
    3: Color := clOlive;
    4: Color := clNavy;
    5: Color := clPurple;
    6: Color := clTeal;
    7: Color := clGray;
    end;
if FColorShapes = ColorFixed2 then
  case FNextShape of
    1: Color := clAqua;
    2: Color := clRed;
    3: Color := clLime;
    4: Color := clYellow;
    5: Color := clBlue;
    6: Color := clFuchsia;
    7: Color := clSilver;
    end;
end;

procedure TTtrs.SetNextSColor (Value: Boolean);
begin
if FNextSColor <> Value then
  FNextSColor := Value;
end;

procedure TTtrs.SetWidthShapesPen (Value: Integer);
begin
if FWidthShapesPen <> Value then FWidthShapesPen := Value;
end;


procedure TTtrs.SetColorF (Value: TColor);
begin
if FColorF <> Value then
  begin
  FColorF := Value;
  Panel1.Color := FColorF;
  end;
end;

procedure TTtrs.SetColumns (Value: Word);
begin
if FColumns <> Value then FColumns := Value;
end;

procedure TTtrs.SetRows (Value: Word);
begin
if FRows <> Value then FRows := Value;
end;

procedure TTtrs.SetTetrisKey (Value: TTSAKey);
begin
if FTetrisKey <> Value then FTetrisKey := Value;
case FTetrisKey of
  Lft: Left;
  Rgh: Right;
  Drp: DropDown;
  Rtt: Rotate;
  end;
end;

procedure TTtrs.Over;
begin
FStart := False;
for i := FRows downto 1 do
  for j := 1 to FColumns do
    if Sh[i,j] <> nil then
      begin
      Sh[i,j].Free;
      Sh[i,j] := nil;
      end;
Panel1.Hide;
if assigned (FOnOver) then FOnOver (Self);
end;

procedure TTtrs.EndFlying;
var
k,l,n: ShortInt;
begin
Timer1.Interval := FDelay;
for n := 1 to 4 do
  for i := FRows downto 1 do
    begin
    k := 0;
    for j := 1 to FColumns do
      if Sh[i,j] <> nil then k := k + 1;
    if k = FColumns then
      begin
      Delete;
      for l := i downto 2 do
        begin
        for j := 1 to FColumns do
          begin
          Sh[l,j].Free; Sh[l,j] := nil;
          end;
        for j := 1 to FColumns do
          if Sh[Pred (l),j] <> nil then
            begin
            Sh[l,j] := TShape.Create (Self);
            CreateShape (Sh[l, j], l, j, 0);
            Sh[l,j].Brush.Color := Sh[Pred (l),j].Brush.Color;
            end;
        end;
      end;
    end;
CreateShapes;
end;

procedure TTtrs.Left;
var
k,j1: ShortInt;
II,JJ: array [1..4] of Shortint;
begin
k := 0;
for i := 1 to FRows do
  for j := 1 to FColumns do
    if Sh[i,j] <> nil then
      if Sh[i,j].Tag <> 0 then
        begin
        j1 := Pred (j);
        if (j = 1) or ((Sh[i,j1] <> nil)and(Sh[i,j1].Tag = 0)) then exit;
        Inc (k);
        II[k] := i; JJ[k] := j;
        if k = 4 then break;
        end;
if k = 4 then
  begin
  for k := 1 to 4 do
    begin
    i := II[k]; j := JJ[k];
    j1 := Pred (j);
    Sh[i,j1] := TShape.Create (Self);
    CreateShape (Sh[i, j1], i, j1, Sh[i, j].Tag);
    Sh[i,j].Free;
    Sh[i,j] := nil;
    end;
  end;
end;

procedure TTtrs.Right;
var
k,j1: ShortInt;
II,JJ: array [1..4] of Shortint;
begin
k := 0;
for i := 1 to FRows do
  for j := FColumns downto 1 do
    if Sh[i,j] <> nil then
      if Sh[i,j].Tag <> 0 then
        begin
        j1 := Succ (j);
        if (j = FColumns) or ((Sh[i,j1] <> nil)and(Sh[i,j1].Tag = 0)) then exit;
        Inc (k);
        II[k] := i; JJ[k] := j;
        if k = 4 then break;
        end;
if k = 4 then
  begin
  for k := 1 to 4 do
    begin
    i := II[k]; j := JJ[k];
    j1 := Succ (j);
    Sh[i,j1] := TShape.Create (Self);
    CreateShape (Sh[i, j1], i, j1, Sh[i, j].Tag);
    Sh[i,j].Free;
    Sh[i,j] := nil;
    end;
  end;
end;

procedure TTtrs.Rotate;
var
i1,j1,i11,j11,i2,j2,i22,j22,i18,i19,j8,j9: ShortInt;
begin
i19 := Pred (FRows); i18 := Pred (i19); j9 := Pred (FColumns); j8 := Pred (j9);
for j := 1 to FColumns do
  for i := FRows downto 1 do
    if Sh[i,j] <> nil then
      if Sh[i,j].Tag > 0 then
        begin
        j1 := Pred (j); j11 := Succ (j); j2 := Pred (j1); j22 := Succ (j11);
        i1 := Pred (i); i11 := Succ (i); i2 := Pred (i1); i22 := Succ (i11);
        if (Sh[i,j].Tag = 1)and(Sh[i1,j] = nil)
            and(Sh[i,j22] = nil)and(i > 1)and(j < j9) then
          begin
          Sh[i1,j] := TShape.Create (Self);
          Sh[i,j22] := TShape.Create (Self);
          CreateShape (Sh[i1, j], i1, j, - 8);
          CreateShape (Sh[i, j22], i, j22, - 8);
          Sh[i22,j].Free; Sh[i11,j].Free;
          Sh[i22,j] := nil; Sh[i11,j] := nil;
          Sh[i,j].Tag := 8;
          Timer1.Enabled := True; Timer2.Enabled := True; exit;
          end;
        if (Sh[i,j].Tag = 8)and(Sh[i2,j] = nil)
            and(Sh[i,j1] = nil)and(i > 2)and(j > 1) then
          begin
          Sh[i2,j] := TShape.Create (Self);
          Sh[i,j1] := TShape.Create (Self);
          CreateShape (Sh[i2, j], i2, j, - 15);
          CreateShape (Sh[i, j1], i, j1, - 15);
          Sh[i,j22].Free; Sh[i,j11].Free;
          Sh[i,j22] := nil; Sh[i,j11] := nil;
          Sh[i,j].Tag := 15;
          exit;
          end;
        if (Sh[i,j].Tag = 15)and(Sh[i,j - 2] = nil)
            and(Sh[i11,j] = nil)and(i < FRows)and(j > 2) then
          begin
          Sh[i,j2] := TShape.Create (Self);
          Sh[i11,j] := TShape.Create (Self);
          CreateShape (Sh[i, j2], i, j2, - 22);
          CreateShape (Sh[i11, j], i11, j, - 22);
          Sh[i1,j].Free; Sh[i2,j].Free;
          Sh[i1,j] := nil; Sh[i2,j] := nil;
          Sh[i,j].Tag := 22;
          exit;
          end;

        if (Sh[i,j].Tag = 22)and(Sh[i,j11] = nil)
            and(Sh[i22,j] = nil)and(j < FColumns)and(i < i19) then
          begin
          Sh[i,j11] := TShape.Create (Self);
          Sh[i22,j] := TShape.Create (Self);
          CreateShape (Sh[i, j11], i, j11, - 1);
          CreateShape (Sh[i22, j], i22, j, - 1);
          Sh[i,j1].Free; Sh[i,j2].Free;
          Sh[i,j1] := nil; Sh[i,j2] := nil;
          Sh[i,j].Tag := 1;
          exit;
          end;

        if (Sh[i,j].Tag = 2)and(Sh[i,j + 1] = nil)and(Sh[i,j + 2] = nil)and(j < j9) then
          begin
          Sh[i,j11] := TShape.Create (Self);
          Sh[i,j22] := TShape.Create (Self);
          CreateShape (Sh[i, j11], i, j11, - 9);
          CreateShape (Sh[i, j22], i, j22, - 9);
          Sh[i,j1].Free; Sh[i22,j].Free;
          Sh[i,j1] := nil; Sh[i22,j] := nil;
          Sh[i,j].Tag := 9;
          exit;
          end;

        if (Sh[i,j].Tag = 9)and(Sh[i - 1,j] = nil)
            and(Sh[i - 2,j] = nil)and(i > 2) then
          begin
          Sh[i1,j] := TShape.Create (Self);
          Sh[i2,j] := TShape.Create (Self);
          CreateShape (Sh[i1, j], i1, j, - 16);
          CreateShape (Sh[i2, j], i2, j, - 16);
          Sh[i11,j].Free; Sh[i,j22].Free;
          Sh[i11,j] := nil; Sh[i,j22] := nil;
          Sh[i,j].Tag := 16;
          exit;
          end;

        if (Sh[i,j].Tag = 16)and(Sh[i,j1] = nil)
            and(Sh[i,j2] = nil)and(j > 2) then
          begin
          Sh[i,j1] := TShape.Create (Self);
          Sh[i,j2] := TShape.Create (Self);
          CreateShape (Sh[i, j1], i, j1, - 23);
          CreateShape (Sh[i, j2], i, j2, - 23);
          Sh[i,j11].Free; Sh[i2,j].Free;
          Sh[i,j11] := nil; Sh[i2,j] := nil;
          Sh[i,j].Tag := 23;
          exit;
          end;

        if (Sh[i,j].Tag = 23)and(Sh[i11,j] = nil)
            and(Sh[i22,j] = nil)and(i < i19) then
          begin
          Sh[i11,j] := TShape.Create (Self);
          Sh[i22,j] := TShape.Create (Self);
          CreateShape (Sh[i11, j], i11, j, - 2);
          CreateShape (Sh[i22, j], i22, j, - 2);
          Sh[i1,j].Free; Sh[i,j2].Free;
          Sh[i1,j] := nil; Sh[i,j2] := nil;
          Sh[i,j].Tag := 2;
          exit;
          end;

        if (Sh[i,j].Tag = 3)and(Sh[i,j11] = nil)and(j < FColumns) then
          begin
          Sh[i,j11] := TShape.Create (Self);
          CreateShape (Sh[i, j11], i, j11, - 10);
          Sh[i1,j].Free;
          Sh[i1,j] := nil;
          Sh[i,j].Tag := 10;
          exit;
          end;

        if (Sh[i,j].Tag = 10)and(Sh[i1,j1] = nil)and(i > 1) then
          begin
          Sh[i - 1,j] := TShape.Create (Self);
          CreateShape (Sh[i1, j], i1, j, - 17);
          Sh[i,j1].Free;
          Sh[i,j1] := nil;
          Sh[i,j].Tag := 17;
          exit;
          end;

        if (Sh[i,j].Tag = 17)and(Sh[i,j1] = nil)and(j > 1) then
          begin
          Sh[i,j1] := TShape.Create (Self);
          CreateShape (Sh[i, j1], i, j1, - 24);
          Sh[i11,j].Free;
          Sh[i11,j] := nil;
          Sh[i,j].Tag := 24;
          exit;
          end;

        if (Sh[i,j].Tag = 24)and(Sh[i11,j] = nil)and(i < FRows) then
          begin
          Sh[i11,j] := TShape.Create (Self);
          CreateShape (Sh[i11, j], i11, j, - 3);
          Sh[i,j11].Free;
          Sh[i,j11] := nil;
          Sh[i,j].Tag := 3;
          exit;
          end;

        if (Sh[i,j].Tag = 4)and(Sh[i1,j1] = nil)
            and(Sh[i1,j] = nil)and(j > 1)and(i > 1) then
          begin
          Sh[i1,j1] := TShape.Create (Self);
          Sh[i1,j] := TShape.Create (Self);
          CreateShape (Sh[i1, j1], i1, j1, - 11);
          CreateShape (Sh[i1, j], i1, j, - 11);
          Sh[i1,j11].Free; Sh[i11,j].Free;
          Sh[i1,j11] := nil; Sh[i11,j] := nil;
          Sh[i,j].Tag := 11;
          exit;
          end;

        if (Sh[i,j].Tag = 11)and(Sh[i,j1] = nil)
            and(Sh[i11,j1] = nil)and(i < FRows) then
          begin
          Sh[i,j1] := TShape.Create (Self);
          Sh[i11,j1] := TShape.Create (Self);
          CreateShape (Sh[i, j1], i, j1, - 18);
          CreateShape (Sh[i11, j1], i11, j1, - 18);
          Sh[i1,j1].Free; Sh[i,j11].Free;
          Sh[i1,j1] := nil; Sh[i,j11] := nil;
          Sh[i,j].Tag := 18;
          exit;
          end;

        if (Sh[i,j].Tag = 18)and(Sh[i11,j] = nil)
            and(Sh[i11,j11] = nil)and(j < FColumns) then
          begin
          Sh[i11,j] := TShape.Create (Self);
          Sh[i11,j11] := TShape.Create (Self);
          CreateShape (Sh[i11, j], i11, j, - 25);
          CreateShape (Sh[i11, j11], i11, j11, - 25);
          Sh[i11,j1].Free; Sh[i1,j].Free;
          Sh[i11,j1] := nil; Sh[i1,j] := nil;
          Sh[i,j].Tag := 25;
          exit;
          end;

        if (Sh[i,j].Tag = 25)and(Sh[i,j11] = nil)
            and(Sh[i1,j11] = nil)and(j < j9) then
          begin
          Sh[i,j11] := TShape.Create (Self);
          Sh[i1,j11] := TShape.Create (Self);
          CreateShape (Sh[i, j11], i, j11, - 4);
          CreateShape (Sh[i1, j11], i1, j + 1, - 4);
          Sh[i,j1].Free; Sh[i11,j11].Free;
          Sh[i,j1] := nil; Sh[i11,j11] := nil;
          Sh[i,j].Tag := 4;
          exit;
          end;

        if (Sh[i,j].Tag = 5)and(Sh[i,j11] = nil)
            and(Sh[i11,j1] = nil)and(j < FColumns) then
          begin
          Sh[i,j11] := TShape.Create (Self);
          Sh[i11,j1] := TShape.Create (Self);
          CreateShape (Sh[i, j11], i, j11, - 12);
          CreateShape (Sh[i11, j1], i11, j1, - 12);
          Sh[i,j1].Free; Sh[i1,j1].Free;
          Sh[i,j1] := nil; Sh[i1,j1] := nil;
          Sh[i,j].Tag := 12;
          exit;
          end;

        if (Sh[i,j].Tag = 12)and(Sh[i1,j] = nil)
            and(Sh[i11,j11] = nil)and(i > 1) then
          begin
          Sh[i1,j] := TShape.Create (Self);
          Sh[i11,j11] := TShape.Create (Self);
          CreateShape (Sh[i1, j], i1, j, - 19);
          CreateShape (Sh[i11, j11], i11, j11, - 19);
          Sh[i11,j1].Free; Sh[i11,j].Free;
          Sh[i11,j1] := nil; Sh[i11,j] := nil;
          Sh[i,j].Tag := 19;
          exit;
          end;

        if (Sh[i,j].Tag = 19)and(Sh[i1,j11] = nil)
            and(Sh[i,j1] = nil)and(i > 1) then
          begin
          Sh[i1,j11] := TShape.Create (Self);
          Sh[i,j1] := TShape.Create (Self);
          CreateShape (Sh[i1, j11], i1, j11, - 26);
          CreateShape (Sh[i, j1], i, j1, - 26);
          Sh[i,j11].Free; Sh[i11,j11].Free;
          Sh[i,j11] := nil; Sh[i11,j11] := nil;
          Sh[i,j].Tag := 26;
          exit;
          end;

        if (Sh[i,j].Tag = 26)and(Sh[i11,j] = nil)
            and(Sh[i1,j1] = nil)and(i < FRows) then
          begin
          Sh[i11,j] := TShape.Create (Self);
          Sh[i1,j1] := TShape.Create (Self);
          CreateShape (Sh[i11, j], i11, j, - 5);
          CreateShape (Sh[i1, j1], i1, j1, - 5);
          Sh[i1,j].Free; Sh[i1,j11].Free;
          Sh[i1,j] := nil; Sh[i1,j11] := nil;
          Sh[i,j].Tag := 5;
          exit;
          end;

        if (Sh[i,j].Tag = 6)and(Sh[i,j1] = nil)
            and(Sh[i,j11] = nil)and(Sh[i,j22] = nil)and(j in [2..j8]) then
          begin
          Sh[i,j1] := TShape.Create (Self);
          Sh[i,j11] := TShape.Create (Self);
          Sh[i,j22] := TShape.Create (Self);
          CreateShape (Sh[i, j1], i, j1, - 13);
          CreateShape (Sh[i, j11], i, j11, - 13);
          CreateShape (Sh[i, j22], i, j22, - 13);
          Sh[i1,j].Free; Sh[i11,j].Free;  Sh[i22,j].Free;
          Sh[i1,j] := nil; Sh[i11,j] := nil;  Sh[i22,j] := nil;
          Sh[i,j].Tag := 13;
          exit;
          end;

        if (Sh[i,j].Tag = 13)and(Sh[i2,j] = nil)
            and(Sh[i1,j] = nil)and(Sh[i11,j] = nil)and(i in [3..i19]) then
          begin
          Sh[i2,j] := TShape.Create (Self);
          Sh[i1,j] := TShape.Create (Self);
          Sh[i11,j] := TShape.Create (Self);
          CreateShape (Sh[i2, j], i2, j, - 20);
          CreateShape (Sh[i1, j], i1, j, - 20);
          CreateShape (Sh[i11, j], i11, j, - 20);
          Sh[i,j1].Free; Sh[i,j11].Free;  Sh[i,j22].Free;
          Sh[i,j1] := nil; Sh[i,j11] := nil;  Sh[i,j22] := nil;
          Sh[i,j].Tag := 20;
          exit;
          end;
        
        if (Sh[i,j].Tag = 20)and(Sh[i,j2] = nil)
            and(Sh[i,j1] = nil)and(Sh[i,j11] = nil)and(j in [3..j9]) then
          begin
          Sh[i,j2] := TShape.Create (Self);
          Sh[i,j1] := TShape.Create (Self);
          Sh[i,j11] := TShape.Create (Self);
          CreateShape (Sh[i, j2], i, j2, - 27);
          CreateShape (Sh[i, j1], i, j1, - 27);
          CreateShape (Sh[i, j11], i, j11, - 27);
          Sh[i2,j].Free; Sh[i1,j].Free;  Sh[i11,j].Free;
          Sh[i2,j] := nil; Sh[i1,j] := nil;  Sh[i11,j] := nil;
          Sh[i,j].Tag := 27;
          exit;
          end;
        
        if (Sh[i,j].Tag = 27)and(Sh[i1,j] = nil)
            and(Sh[i11,j] = nil)and(Sh[i22,j] = nil)and(i in [2..i18]) then
          begin
          Sh[i1,j] := TShape.Create (Self);
          Sh[i11,j] := TShape.Create (Self);
          Sh[i22,j] := TShape.Create (Self);
          CreateShape (Sh[i1, j], i1, j, - 6);
          CreateShape (Sh[i11, j], i11, j, - 6);
          CreateShape (Sh[i22, j], i22, j, - 6);
          Sh[i,j2].Free; Sh[i,j1].Free;  Sh[i,j11].Free;
          Sh[i,j2] := nil; Sh[i,j1] := nil;  Sh[i,j11] := nil;
          Sh[i,j].Tag := 6;
          exit;
          end;
        end;
end;

procedure TTtrs.DropDown;
begin
Timer1.Interval := 20;
end;

procedure TTtrs.SetTetrisKeyDown (value: Word);
begin
FTetrisKeyDown := Value;
case FTetrisKeyDown of
  VK_NumPad2: DropDown;
  VK_NumPad4: Left;
  VK_NumPad5: Rotate;
  VK_NumPad6: Right;
  end;
end;

procedure TTtrs.Paint;
begin
inherited Paint;
if not FFirstFocus then
  begin
  if CanFocus then SetFocus;
  FFirstFocus := True;
  end;
if assigned (FOnPaint) then FOnPaint (Self);
end;

procedure TTtrs.Resize;
begin
inherited Resize;
if Panel1<>nil then if FStart = False then
  begin
  Panel1.Height := 0; exit;
  end;
he := Trunc (Height div FRows);
wi := Trunc (Width div FColumns);
x := (Width - FColumns * wi) div 2;
for i := 1 to FRows do
  for j := 1 to FColumns do
    if Sh[i,j] <> nil then
      Sh[i,j].SetBounds (wi * Pred (j) + x, he * Pred (i), wi, he);
if Panel1<>nil then Panel1.SetBounds (0, FRows * he, Width, Height - FRows * he);
end;

procedure TTtrs.WMNCHitTest (var Mes: TWMNCHitTest);
begin
inherited;
if Mes.Result = htClient then Mes.Result := htCaption;
SetFocus;
end;

                             { TTetPanel  }

constructor TTetPanel.Create (AOwner: TComponent);
begin
inherited Create (AOwner);
FState := StPanel;
FStart := False; FPause := False; FTime := 0.0;
FAbout := ' Alexander Gogava 1998';
FTRows := 20; FTColumns := 10;
FNextTShape := 7;
FTScores := 0; FTLines := 0;
FColorTB := clBlack;
FColorTF := clBlack;
FColorTShapes := colorFixed;
FOneColorTShapes := clBtnFace;
FColorTShapesPen := clWhite;
FWidthTShapesPen := 1;
FTDelay := 200;
FNextSColorT := False;
FShapesTShape := stRoundRect;
FShapesTBrushStyle := bsSolid;
FShowScoresTime := True;
FPicStretch := True;
FTimerFocus := False;
FDefKeys := True;
FTCoeff := 1;
FAOverPicture := '';
FBStPicture := '';
FWithCaption := True;
FShowAllDlgs := True;
Ttrs1 := nil;
Pict := nil;
end;

destructor TTetPanel.Destroy;
begin
if Ttrs1 <> nil then Ttrs1.Free;
if Pict <> nil then Pict.Free;
inherited Destroy;
end;

procedure TTetPanel.Resize;
begin
inherited Resize;
if State=stPanel then exit;
if Height<50 then Height:=50;
if Width<50 then Width:=50;
end;

procedure TTetPanel.ChangeParams;
begin
FStyle := GetWindowLong (Handle, GWL_STYLE);
if FWithCaption then FStyle := (FStyle xor WS_Caption xor WS_THICKFRAME)
else
  FStyle := (FStyle xor WS_THICKFRAME);
SetWindowLong (Handle, GWL_STYLE, FStyle);
if FState = StPanel then
  SetWindowPos (Handle, HWND_TOP, fx, fy, fcx, fcy, SWP_DRAWFRAME)
else
  begin
  fx := Left; fy := Top; fcx := Width; fcy := Height;
  SetWindowPos (Handle, HWND_TOP, 0, 0, 0, 0,
    SWP_NOMOVE or SWP_NOSIZE or SWP_NOZORDER or SWP_DRAWFRAME
    or SWP_NOACTIVATE);
  end;
end;

procedure TTetPanel.TetrisOver (Sender: TObject);
begin
if Ttrs1<>nil then Ttrs1.Start:=False;
FStart := False;
if assigned (FOnTetrisOver) then FOnTetrisOver (Self);
try
if FAOverPicture <> '' then
begin
try
  if Pict = nil then Pict := TPicture.Create;
  Pict.LoadFromFile (FAOverPicture);
except
ShowMessage('Cannot Open '+FAOverPicture);
Pict.Free; Pict:=nil; FAOverPicture:='';
end;
end;
Finally
  if Ttrs1 <> nil then Ttrs1.Invalidate;
PanelSetFocus;
end;
end;

procedure TTetPanel.TetrisContact (Sender: TObject);
begin
FNextTShape := TTrs1.NextShape;
if assigned (FOnTetrisContact) then FOnTetrisContact (Self);
end;


procedure TTetPanel.TetrisDelete (Sender: TObject);
begin
FTLines := FTLines + 1;
FTScores := FTScores + FTCoeff;
if assigned (FOnTetrisDelete) then FOnTetrisDelete (Self);
PanelSetFocus;
end;



procedure TTetPanel.TetrisPaint (Sender: TObject);
begin
if Ttrs1 <> nil then
  with Ttrs1 do
    if Start = False then
      if Pict <> nil then
        if PicStretch then
          Canvas.StretchDraw (ClientRect, Pict.Graphic)
        else Canvas.Draw (0, 0, Pict.Graphic);
end;



procedure TTetPanel.STAFTime;
begin
if FTimerFocus then PanelSetFocus;
FTime := FTime + 1.0;
if State = Tetris then
  if Ttrs1 <> nil then
    begin
    if assigned (FOnTetrisTime) then FOnTetrisTime (Self);
    if ShowScoresTime = False then
      begin
      Caption := ''; exit;
      end;
    Str (Time: 6: 0, Tmp);
    Caption := 'Scores: ' + IntToStr (FTScores) + ' Time:' + Tmp;
    end;
end;

procedure TTetPanel.TetPanelKeyDown
(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
inherited KeyDown (Key, Shift);
if not FDefKeys then Exit;
if State=Tetris then
    if Ttrs1 <> nil then
      if (TTrs1.Start) and (not Ttrs1.Pause) then
        Ttrs1.TetrisKeyDown := key;
PanelSetFocus;
end;

procedure TTetPanel.ChangeState;
begin
if FState = StPanel then
   begin
   if Ttrs1 <> nil then
    begin
    Ttrs1.Free;
    Ttrs1 := nil;
    ChangeParams;
    Caption := temp;
    FStart := False;
    FPause := False;
    end;
  if Pict <> nil then
    begin
    Pict.Free; Pict := nil;
    end;
  end
else
   if State = Tetris then
   begin
    ChangeParams;
    temp := Caption;
    Caption := 'PLEASE WAIT';
    Ttrs1 := TTtrs.Create (Self);
    with Ttrs1 do
      begin
      Start := False;
      Columns := FTColumns;
      Rows := FTRows;
      Align := AlClient;
      Pause := False;
      Caption := '';
      Color := FColorTB;
      ColorF := FColorTF;
      ColorShapes := FColorTShapes;
      NextSColor := FNextSColorT;
      NextShape := FNextTShape;
      ShapesBrushStyle := FShapesTBrushStyle;
      ColorShapesPen := FColorTShapesPen;
      WidthShapesPen := FWidthTShapesPen;
      ShapesShape := FShapesTShape;
      OneColorShapes := FOneColorTShapes;
      Delay := FTDelay;
      OnKeyDown := TetPanelKeyDown;
      OnDelete := TetrisDelete;
      OnOver := TetrisOver;
      OnContact := TetrisContact;
      OnTime := STAFTime;
      OnPaint := TetrisPaint;
      TabStop := True;
      Parent := Self;
      end;
    FTLines := 0;
    case ShowScoresTime of
      True:    Caption := 'Scores: 0; Time     0';
      False:     Caption := '';
      end;
    if Pict <> nil then
      begin
      Pict.Free; Pict := nil;
      end;
try
 if FBStPicture <> '' then
   if Pict = nil then Pict := TPicture.Create;
    if Pict <> nil then Pict.LoadFromFile (FBStPicture);
 Except
   ShowMessage('Cannot Open '+FBStPicture);
   Pict.Free; Pict:=nil; FBStPicture:='';
 end;
   Ttrs1.Invalidate;
   end;
 end;


procedure TTetPanel.SetTCoeff (Value: Integer);
begin
try
  if FTCoeff <> Value then FTCoeff := Value;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetGKey (Value: TTSAKey);
begin
try
if (State = Tetris) and (Ttrs1 <> nil) and (Value in [Lft..Rtt]) then
  begin
  if FGKey <> Value then FGKey := Value;
  if FStart then
    if not FPause then TTrs1.TetrisKey := FGKey;
  end;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetShowScoresTime (Value: Boolean);
begin
try
  if FShowScoresTime <> Value then FShowScoresTime := Value;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetState (Value: TState);
begin
if FState=Value then exit;
FState:=Value;
if not (csDesigning in ComponentState) then ChangeState;
end;

procedure TTetPanel.SetStart (Value: Boolean);
begin
if csDesigning in ComponentState then
  begin
  FStart := Value; exit;
  end;

if FState = Tetris then
  if TTrs1 <> nil then
    if FStart <> Value then
      if FStart = False then
        begin
        Ttrs1.Invalidate;
        FStart := Value;
        FTScores := 0; FTLines := 0;
        Ttrs1.Caption := '';
        FTLines := 0;
        FTime := 0.0;
        case ShowScoresTime of
          True:    Caption := 'Scores: 0';
          False:     Caption := '';
          end;
        if Pict<>nil then begin Pict.Free; Pict:=nil; end;
        With Ttrs1 do
        begin
        Rows := FTRows;
        Columns := FTColumns;
        Start := True;
        end;
        end;
PanelSetFocus;
end;

procedure TTetPanel.SetPause (Value: Boolean);
begin
try
  if csDesigning in ComponentState then exit;

if FState = Tetris then
  if Ttrs1 <> nil then
    if FPause <> Value then
      begin
      if FStart = False then
        begin
        PanelSetFocus; Exit;
        end;
      FPause := Value;
      Ttrs1.Pause := Value;
      if not FPause then Ttrs1.Align:=AlClient;
      end;

finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetColorTF (Value: TColor);
begin
try
  if FColorTF <> Value then
  begin
  FColorTF := Value;
  if State = Tetris then 
    if Ttrs1 <> nil then Ttrs1.ColorF := FColorTF;
  end;
finally
  PanelSetFocus;
end;
end;



procedure TTetPanel.SetTDelay (Value: Integer);
begin
try
  if FTDelay <> Value then FTDelay := Value;
if State = Tetris then 
  if Ttrs1 <> nil then TTrs1.Delay := FTDelay;
finally
  PanelSetFocus;
end;
end;


procedure TTetPanel.SetColorTShapes (Value: TColorTAFShapes);
begin
try
  if FColorTShapes <> Value then
  begin
  FColorTShapes := Value;
  if State = Tetris then 
    if Ttrs1 <> nil then
      Ttrs1.ColorShapes := FColorTShapes;
  end;
finally
  PanelSetFocus;
end;
end;
procedure TTetPanel.SetWithCaption (Value: Boolean);
begin
try
  if (not (csDesigning in ComponentState))and (State <> stPanel) then
  begin
  MessageDlg ('At run time change this option only if State=sTetPanel',
    mtError, [mbOK], 0);
  end
else
  if FWithCaption <> Value then FWithCaption := Value;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetOneColorTShapes (Value: TColor);
begin
try
  if FOneColorTShapes <> Value then
  begin
  FOneColorTShapes := Value;
  if State = Tetris then
    if Ttrs1 <> nil then
      Ttrs1.OneColorShapes := FOneColorTShapes;
  end;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetTimerFocus (Value: Boolean);
begin
try
if FTimerFocus <> Value then FTimerFocus := Value;
finally
PanelSetFocus;
end;
end;

procedure TTetPanel.SetDefKeys (Value: Boolean);
begin
try
  if FDefKeys <> Value then FDefKeys := Value;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetPicStretch (Value: Boolean);
begin
try
  if FPicStretch <> Value then FPicStretch := Value;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetShowAllDlgs (Value: Boolean);
begin
try
  if FShowAllDlgs <> Value then FShowAllDlgs := Value;
finally
  PanelSetFocus;
end;
end;



procedure TTetPanel.SetColorTShapesPen (Value: TColor);
begin
try
  if FColorTShapesPen <> Value then
  begin
  FColorTShapesPen := Value;
  if State = Tetris then
    if Ttrs1 <> nil then
      Ttrs1.ColorShapesPen := FColorTShapesPen;
  end;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetWidthTShapesPen (Value: Integer);
begin
try
  if not Value > 0 then
  MessageDlg ('Value must be >0', mtError, [mbOK], 0)
else
  if FWidthTShapesPen <> Value then
    begin
    FWidthTShapesPen := Value;
    if State = Tetris then 
      if Ttrs1 <> nil then
        Ttrs1.WidthShapesPen := FWidthTShapesPen;
    end;
finally
  PanelSetFocus;
end;
end;



procedure TTetPanel.SetColorTB (Value: TColor);
begin
try
  if FColorTB <> Value then
  begin
  FColorTB := Value;
  if State = Tetris then
    if Ttrs1 <> nil then Ttrs1.Color := FColorTB;
  end;
finally
  PanelSetFocus;
end;
end;



procedure TTetPanel.SetNextSColorT (Value: Boolean);
begin
try
  if FNextSColorT <> Value then
  begin
  FNextSColorT := Value;
  if State = Tetris then
    if Ttrs1 <> nil then
      Ttrs1.NextSColor := FNextSColorT;
  end;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetNextTShape (Value: Word);
begin
if not Value in [1..7] then
  begin
  MessageDlg ('Value must be in [1..7]', mtError, [mbOK], 0);
  PanelSetFocus;
  exit;
  end;
try
  if FNextTShape <> Value then
  begin
  FNextTShape := Value;
  if State = Tetris then
    if Ttrs1 <> nil then
      begin
      Ttrs1.NextShape := FNextTShape;
      end;
  end;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetShapesTShape (Value: TShapeType);
begin
try
  if FShapesTShape <> Value then
  begin
  FShapesTShape := Value;
  if State = Tetris then 
    if TTrs1 <> nil then Ttrs1.ShapesShape := FShapesTShape;
  end;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetShapesTBrushStyle (Value: TBrushStyle);
begin
try
  if FShapesTBrushStyle <> Value then
  begin
  FShapesTBrushStyle := Value;
  if State = Tetris then 
    if TTrs1 <> nil then
      Ttrs1.ShapesBrushStyle := FShapesTBrushStyle;
  end;
finally
  PanelSetFocus;
end;
end;


procedure TTetPanel.SetBStPicture (Value: string);
begin
try
if FBStPicture <> Value then
  FBStPicture := Value;
finally
  PanelSetFocus;
end;
end;

procedure TTetPanel.SetAOverPicture (Value: string);
begin
try
if FAOverPicture <> Value then
FAOverPicture := Value;
finally
PanelSetFocus;
end;
end;

procedure TTetPanel.SeTTRows (Value: Word);
begin
if not Value in [6..48] then
begin
MessageDlg ('Value must be in [6..48]', mtError, [mbOK], 0);
PanelSetFocus;
exit;
end;
try
  if FTRows <> Value then
    begin
    FTRows := Value;
    if State = Tetris then
      if Ttrs1 <> nil then
        if not Ttrs1.Start then Ttrs1.Rows := FTRows
        else
          if FShowAllDlgs then
            MessageDlg ('Restart Tetris to have effect this option',
              mtInformation, [mbOK], 0);
    end;
finally
  PanelSetFocus;
end;
end;


procedure TTetPanel.SeTTColumns (Value: Word);
begin
  if not Value in [6..24] then
  begin
  MessageDlg ('Value must be in [6..24]', mtError, [mbOK], 0);
PanelSetFocus;
exit;
end;
try
  if FTColumns <> Value then
    begin
    FTColumns := Value;
    if State = Tetris then
      if Ttrs1 <> nil then
        if not Ttrs1.Start then Ttrs1.Columns := FTColumns
        else
          if FShowAllDlgs then
            MessageDlg ('Restart Tetris to have effect this option',
              mtInformation, [mbOK], 0);
    end;
finally
  PanelSetFocus;
end;
end;



procedure TTetPanel.PanelSetFocus;
begin
if (not FDefKeys) or Pause or not Start then exit;
if State=Tetris then
    if Ttrs1 <> nil then 
      if Ttrs1.FirstFocus then 
        if not Ttrs1.Focused then
          TTrs1.SetFocus;

end;

end.





